/*
 * Ovo je je C kod ECHO servera
 * Koristi sockete za komunikaciju,
 * errno sistem za ispisivanje
 * obavestenja i gresaka
 * 
 * Ima dva bafera, pri cemu jedan
 * prihvata korisnicki unos i sluzi
 * za slanje tih podataka preko socketa
 * dok drugi ima fiksnu velicinu i 
 * sluzi za prihvatanje podataka iz
 * sistemskog bafera
 * 
 * Za citanje sa stdin ulaza, koristi
 * se getline funkcija, jer scanf string
 * od vise reci deli prema razmaku, pa
 * se zbog toga i komunikacija poremeti
 * i izgubi se potpuna kontrola u pogledu
 * ko je sledeci koji salje a ko prima podatke.
 * 
 * Ne moramo da vodimo racuna o '\0' 
 * karakteru na kraju stringa posto
 * se na njegovom kraju uvek nadje '\n'
 * zbog nacina na koji se snima unos
 * korisnicke poruke
 * 
 * Kodirao: Ikac, e-mail: ikac.ikax@gmail.com
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

int main(int argc, char **argv)
{

  int sockfd, newsockfd, portno;
	int n;

	struct sockaddr_in serv_addr;

 
	if (argc < 2) {
		fprintf(stderr, "uputstvo: %s port\n", argv[0]);
		exit(1);
	}

	sockfd = socket(AF_INET, SOCK_STREAM, 0);	//kreiranje socket-a koji ce sluziti da osluskujemo zahteve za konekcijama
	perror("Creating socket");

	if (sockfd < 0)
		exit(1);

	memset(&serv_addr, '0', sizeof(serv_addr));

	portno = atoi(argv[1]);	//prihvatamo zeljeni port

	serv_addr.sin_family = AF_INET;	//koriste se Internet adrese
	serv_addr.sin_addr.s_addr = INADDR_ANY;	//slusamo i na javnoj adresi i lokalnoj
	serv_addr.sin_port = htons(portno);	//slusamo na zeljenom portu

	n = bind(sockfd, (struct sockaddr *)&serv_addr, sizeof(serv_addr));
	perror("Vezivanje za zeljeni port");

	if (n < 0)
		exit(1);

	n = listen(sockfd, 5);
	perror("Server osluskuje moguce zajteve");

	if (n < 0)
		exit(1);

	// ZAVRSETAK FIKSNOG DELA
  
	char *buffer_out;	//skladiste za podatke koji se salju
	char buffer_in[256];	//skladiste za podatke koje cemo primiti
	int nbytes;		//broj bajtova koje smo primili u skladiste za prijem

	while (1) {
		newsockfd = accept(sockfd, 0, 0);	//prihvatanje konekcije ne vodeci brigu o podacima klijenta
		perror("Prihvatanje konekcije");
        
		if (newsockfd < 0)
			break;

		else {
			while (1) {
				memset(buffer_in, ' ', 256);
				n = read(newsockfd, buffer_in, 256);
				perror("Prihvatanje poruke");

				if (n < 0)
					break;

				printf("Klijent: %s\n", buffer_in);

				printf("Unesi poruku: ");
				getline(&buffer_out, &nbytes, stdin);

				if (nbytes > 256)
					printf
					    ("Poruka je ogranicena na 256 karaktera. Ostatak ce biti zanemaren\n");

				n = write(newsockfd, buffer_out, 256);
				perror("Pisanje u socket");

				if (n < 0)
					break;

			}
			close(newsockfd);
      perror("Zatvaram konekciju");
		}
	}

	close(sockfd);
	return (0);
}
